#!/bin/bash

runone() {
	local nfq_pid
	if [ "$1" != "" ]; then
		ip netns exec nfqc chrt -rr 99 $1 > /dev/null &
		#ip netns exec nfqc $1 > /dev/null &
		nfq_pid=$!
		ip netns exec nfqc iptables -A OUTPUT -j NFQUEUE --queue-num 0
	else
		ip netns exec nfqc iptables -F OUTPUT
	fi

	ip netns exec nfqc iptables -L -n

	echo -e "----- ping ($2):\n"
	ip netns exec nfqc ping -c 5000 -i 0.001 -q 10.11.0.1 | grep -v -e '^$'

	echo -e "\n----- iperf3 ($2):\n"
	ip netns exec nfqs iperf3 -s -1 > /dev/null &
	sleep 1
	ip netns exec nfqc iperf3 -t 5 -c 10.11.0.1 | grep -v -e '^$'

	if [ "$1" != "" ]; then
		ip netns exec nfqc iptables -F OUTPUT
		ip netns exec nfqc kill $nfq_pid
		sleep 1
	fi
}

# no nfqueue
#runone "" "no nfqueue"

# nfqueue without GSO
#echo && runone "./nfq" "nfqueue without GSO"

# nfqueue with GSO
echo && runone "./nfq-gso 0" "nfqueue with GSO"
